%bayesometer
% Visual demonstration of Bayesian inference.
% LAST UPDATED by Andy French. February 2014.

function varargout = bayesometer(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @bayesometer_OpeningFcn, ...
    'gui_OutputFcn',  @bayesometer_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%%

function bayesometer_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for bayesometer
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

%Centre figure
figcentre(gcf);

%Initialize data structure d, and store handles of GUI objects within it.
global d
handles = guidata(gcf);
d.h = handles;

%Load tree diagram and Thomas Bayes images
axes(d.h.AXEStreediagram);
image( imread('tree_diagrams.jpg'));
axis equal
axis off;
axes(d.h.AXESbayes);
image( imread('thomas_bayes.jpg'));
axis equal
axis off;

%Update GUI
gui_update;

%%

%Probability of hypothesis being true edit box
function EDITPH_Callback(hObject, eventdata, handles)
gui_update;

%%

%Probability of passing test given hypothesis true
function EDITPTgivenH_Callback(hObject, eventdata, handles)
gui_update;

%%

%Probability of passing test given hypothesis false
function EDITPTgivennotH_Callback(hObject, eventdata, handles)
gui_update;

%%

function varargout = bayesometer_OutputFcn(hObject, eventdata, handles)

%%

% GUI update function
function gui_update
global d

%Get inputs from edit boxes
d.P_H = str2num( get( d.h.EDITPH, 'string' ) );
d.P_TgivenH = str2num( get( d.h.EDITPTgivenH, 'string' ) );
d.P_TgivennotH = str2num( get( d.h.EDITPTgivennotH, 'string' ) );

%Compute other parameters
d.P_notH = 1 - d.P_H;
d.P_notTgivenH = 1 - d.P_TgivenH;
d.P_notTgivennotH = 1 - d.P_TgivennotH;
d.P_T = d.P_H * d.P_TgivenH + d.P_notH * d.P_TgivennotH;
d.P_notT = 1 - d.P_T;
d.P_HgivenT = d.P_H * d.P_TgivenH / d.P_T;
d.P_notHgivenT = 1 - d.P_HgivenT;
d.P_HgivennotT = d.P_H * d.P_notTgivenH / d.P_notT;
d.P_notHgivennotT = 1 - d.P_HgivennotT;

%Update GUI edit boxes and text boxes
set( d.h.EDITPnotH, 'string', num2str( d.P_notH,3 ) );
set( d.h.EDITPnotTgivenH , 'string', num2str( d.P_notTgivenH,3  ) );
set( d.h.EDITPnotTgivennotH, 'string', num2str( d.P_notTgivennotH,3 ) );
set( d.h.EDITPT, 'string', num2str( d.P_T,3 ) );
set( d.h.EDITPnotT, 'string', num2str( d.P_notT,3 ) );
set( d.h.EDITPHgivenT, 'string', num2str( d.P_HgivenT,3 ) );
set( d.h.EDITPnotHgivenT, 'string', num2str( d.P_notHgivenT,3 ) );
set( d.h.EDITPHgivennotT, 'string', num2str( d.P_HgivennotT,3 ) );
set( d.h.EDITPnotHgivennotT, 'string', num2str( d.P_notHgivennotT,3 ) );
set( d.h.TEXTPHgivenT, 'string', num2str( d.P_HgivenT,3 ) );
set( d.h.TEXTPnotHgivenT, 'string', num2str( d.P_notHgivenT,3 ) );
set( d.h.TEXTPHgivennotT, 'string', num2str( d.P_HgivennotT,3 ) );
set( d.h.TEXTPnotHgivennotT, 'string', num2str( d.P_notHgivennotT,3 ) );

%%

%Centre figure in screen
function figcentre(fig)

%Get screen dimensions in pixels.
set(0,'units','pixels') ;
screen_size=get(0,'Screensize');

%Get original figure units
orig_units = get(fig,'units');

%Get position vector for figure in pixels
set(fig,'units','pixels');
fig_position=get(gcf,'position') ;

%Define coordinates or figure bottom hand corner from screen bottom hand corner
%that will place the figure window in the center of the screen.
centre_x = 0.5*screen_size(3) - 0.5*fig_position(3);
centre_y = 0.5*screen_size(4) - 0.5*fig_position(4);

%Modify figure position to centre
set(fig,'position',[centre_x,centre_y,fig_position(3),fig_position(4)] );

%Reset figure units
set(fig,'units',orig_units);

%End of code

