%coloursquare
% A nice and aesthetic colour picker!
%
% LAST UPDATED by Andy French February 2017

function varargout = coloursquare(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @coloursquare_OpeningFcn, ...
    'gui_OutputFcn',  @coloursquare_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%%

% GUI opening function
function coloursquare_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for coloursquare
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

%Create a global variable d
global d
d.h = handles;

%Centre figure in screen
figcentre(gcf);

%Set default colours
c = randi(255,1,3);
d.R = c(1);
d.G = c(2);
d.B = c(3);

%Update the GUI boxes and sliders

%Red
set( d.h.EDITR, 'string', num2str( d.R ) );
v = d.R/255;
set( d.h.SLIDERR, 'value', v  );
set( d.h.SLIDERR, 'Backgroundcolor', [d.R/255,0,0] );
c = v*[1,0,0] + (1-v)*[1,1,1];
set( d.h.SLIDERR, 'Backgroundcolor', c );

%Green
set( d.h.EDITG, 'string', num2str( d.G ) );
v = d.G/255;
set( d.h.SLIDERG, 'value', 1-v  );
set( d.h.SLIDERG, 'Backgroundcolor', [0,d.G/255,0] );
c = v*[0,1,0] + (1-v)*[1,1,1];
set( d.h.SLIDERG, 'Backgroundcolor', c );

%Blue
set( d.h.EDITB, 'string', num2str( d.B ) );
v = d.B/255;
set( d.h.SLIDERB, 'value', 1-v  );
set( d.h.SLIDERB, 'Backgroundcolor', [0,0,d.B/255] );
c = v*[0,0,1] + (1-v)*[1,1,1];
set( d.h.SLIDERB, 'Backgroundcolor', c );

%Set initial colour of colour box
set( d.h.TEXTsquare,'BackGroundColor',[d.R,d.G,d.B]/255 );
set( d.h.TEXTinverse,'BackGroundColor',1-[d.R,d.G,d.B]/255 );

%%

% Outputs from this function are returned to the command line.
function varargout = coloursquare_OutputFcn(hObject, eventdata, handles)

% Get default command line output from handles structure
varargout{1} = handles.output;

%%

% Edit box which contains the Red colour value
function EDITR_Callback(hObject, eventdata, handles)
global d
d.R = round( str2num( get( d.h.EDITR, 'string' ) ) );
if d.R < 0
    d.R = 0;
elseif d.R > 255
    d.R = 255;
end

%Update colour box
set( d.h.TEXTsquare,'BackGroundColor',[d.R,d.G,d.B]/255 );
set( d.h.TEXTinverse,'BackGroundColor',1-[d.R,d.G,d.B]/255 );

%Update edit box
set( d.h.EDITR,'string', num2str( d.R ) );

%Update the slider
v = d.R/255;
set( d.h.SLIDERR,'value',v );

%Update slider background colour
c = v*[1,0,0] + (1-v)*[1,1,1];
set( d.h.SLIDERR, 'Backgroundcolor', c );

%%

% Edit box which contains the Green colour value
function EDITG_Callback(hObject, eventdata, handles)
global d
d.G = round( str2num( get( d.h.EDITG, 'string' ) ) );
if d.G < 0
    d.G = 0;
elseif d.G > 255
    d.G = 255;
end

%Update colour box
set( d.h.TEXTsquare,'BackGroundColor',[d.R,d.G,d.B]/255 );
set( d.h.TEXTinverse,'BackGroundColor',1-[d.R,d.G,d.B]/255 );

%Update edit box
set( d.h.EDITG,'string', num2str( d.G ) );

%Update the slider
v = d.G/255;
set( d.h.SLIDERG,'value',1-v );

%Update slider background colour
c = v*[0,1,0] + (1-v)*[1,1,1];
set( d.h.SLIDERG, 'Backgroundcolor', c );

%%

% Edit box which contains the Blue colour value
function EDITB_Callback(hObject, eventdata, handles)
global d
d.B = round( str2num( get( d.h.EDITB, 'string' ) ) );
if d.B < 0
    d.B = 0;
elseif d.B > 255
    d.B = 255;
end

%Update colour box
set( d.h.TEXTsquare,'BackGroundColor',[d.R,d.G,d.B]/255 );
set( d.h.TEXTinverse,'BackGroundColor',1-[d.R,d.G,d.B]/255 );

%Update edit box
set( d.h.EDITB,'string', num2str( d.B ) );

%Update the slider
v = d.B/255;
set( d.h.SLIDERB,'value',1-v);

%Update slider background colour
c = v*[0,0,1] + (1-v)*[1,1,1];
set( d.h.SLIDERB, 'Backgroundcolor', c );

%%

% Slider which modifies the Red colour
function SLIDERR_Callback(hObject, eventdata, handles)
global d

%Get the slider value
v = get( d.h.SLIDERR, 'value' );

%Work out new colour
d.R = round( v*255 );

%Update slider background colour
c = v*[1,0,0] + (1-v)*[1,1,1];
set( d.h.SLIDERR, 'Backgroundcolor', c );

%Update colour box
set( d.h.TEXTsquare,'BackGroundColor',[d.R,d.G,d.B]/255 );
set( d.h.TEXTinverse,'BackGroundColor',1-[d.R,d.G,d.B]/255 );

%Update edit box
set( d.h.EDITR,'string', num2str( d.R ) );

%%

% Slider which modifies the Green colour
function SLIDERG_Callback(hObject, eventdata, handles)
global d

%Get the slider value
v = 1-get( d.h.SLIDERG, 'value' );

%Work out new colour
d.G = round( v*255 );

%Update slider background colour
c = v*[0,1,0] + (1-v)*[1,1,1];
set( d.h.SLIDERG, 'Backgroundcolor', c );

%Update colour box
set( d.h.TEXTsquare,'BackGroundColor',[d.R,d.G,d.B]/255 );
set( d.h.TEXTinverse,'BackGroundColor',1-[d.R,d.G,d.B]/255 );

%Update edit box
set( d.h.EDITG,'string', num2str( d.G ) );

%%

% Slider which modifies the Blue colour
function SLIDERB_Callback(hObject, eventdata, handles)
global d

%Get the slider value
v = 1-get( d.h.SLIDERB, 'value' );

%Work out new colour
d.B = round( v*255 );

%Update slider background colour
c = v*[0,0,1] + (1-v)*[1,1,1];
set( d.h.SLIDERB, 'Backgroundcolor', c );

%Update colour box
set( d.h.TEXTsquare,'BackGroundColor',[d.R,d.G,d.B]/255 );
set( d.h.TEXTinverse,'BackGroundColor',1-[d.R,d.G,d.B]/255 );

%Update edit box
set( d.h.EDITB,'string', num2str( d.B ) );

%%

%Centre figure in screen
function figcentre(fig)

%Get screen dimensions in pixels.
set(0,'units','pixels') ;
screen_size=get(0,'Screensize');

%Get original figure units
orig_units = get(fig,'units');

%Get position vector for figure in pixels
set(fig,'units','pixels');
fig_position=get(gcf,'position') ;

%Define coordinates or figure bottom hand corner from screen bottom hand corner
%that will place the figure window in the center of the screen.
centre_x = 0.5*screen_size(3) - 0.5*fig_position(3);
centre_y = 0.5*screen_size(4) - 0.5*fig_position(4);

%Modify figure position to centre
set(fig,'position',[centre_x,centre_y,fig_position(3),fig_position(4)] );

%Reset figure units
set(fig,'units',orig_units);

%End of code


