%fgraph
% A simple graphing application.
% LAST UPDATED by Andy French. December 2013.

function varargout = fgraph(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @fgraph_OpeningFcn, ...
    'gui_OutputFcn',  @fgraph_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%%

function fgraph_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for fgraph
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

global d
%Load d from previous settings
try
load settings
    
    %Update the GUI with settings data
    set( handles.EDITeqa1,'string',d.eqa1 );
    set( handles.EDITeqa2,'string',d.eqa2 );
    set( handles.EDITeqa3,'string',d.eqa3 );
    set( handles.EDITeqa4,'string',d.eqa4 );
    set( handles.EDITeqa5,'string',d.eqa5 );
    set( handles.CHECKeqa1,'value',d.eqa1_show );
    set( handles.CHECKeqa2,'value',d.eqa2_show );
    set( handles.CHECKeqa3,'value',d.eqa3_show );
    set( handles.CHECKeqa4,'value',d.eqa4_show );
    set( handles.CHECKeqa5,'value',d.eqa5_show );
    set( handles.EDITxmin,'string',num2str( d.xmin )) ;
    set( handles.EDITymin,'string',num2str( d.ymin )) ;
    set( handles.EDITxmax,'string',num2str( d.xmax )) ;
    set( handles.EDITymax,'string',num2str( d.ymax )) ;
    set( handles.EDITxtick,'string',num2str( d.xtick )) ;
    set( handles.EDITytick,'string',num2str( d.ytick )) ;
    set( handles.CHECKxyscale,'value',d.xyscale );    
end
handles = guidata(gcf);
d.h = handles;
gui_update;
figcentre(gcf);

%%

%Equation 1 edit box callback
function EDITeqa1_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 2 edit box callback
function EDITeqa2_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 3 edit box callback
function EDITeqa3_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 4 edit box callback
function EDITeqa4_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 5 edit box callback
function EDITeqa5_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 1 check box callback
function CHECKeqa1_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 2 check box callback
function CHECKeqa2_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 3 check box callback
function CHECKeqa3_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 4 check box callback
function CHECKeqa4_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 5 check box callback
function CHECKeqa5_Callback(hObject, eventdata, handles)
gui_update

%%

% y axis maximum edit box callback
function EDITymax_Callback(hObject, eventdata, handles)
gui_update

%%

% y axis minimum edit box callback
function EDITymin_Callback(hObject, eventdata, handles)
gui_update

%%

% x axis minimum edit box callback
function EDITxmin_Callback(hObject, eventdata, handles)
gui_update

%%

% x axis maximum edit box callback
function EDITxmax_Callback(hObject, eventdata, handles)
gui_update

%%

% xtick edit box callback
function EDITxtick_Callback(hObject, eventdata, handles)
gui_update

%%

% ytick edit box callback
function EDITytick_Callback(hObject, eventdata, handles)
gui_update

%%

% x,y equal scales checkbox callback
function CHECKxyscale_Callback(hObject, eventdata, handles)
gui_update

%%

% Print PNG pushbutton
function PUSHprintPNG_Callback(hObject, eventdata, handles)
fig = figure; ax = axes;
plot_graph;
print(fig,['fgraph ',strrep(datestr(now),':','-')],'-djpeg','-r300');
close(fig);

%%

function varargout = fgraph_OutputFcn(hObject, eventdata, handles)

%%

% GUI update function
function gui_update
global d

%%% Inputs %%%

%Set number of data points
d.N = 1000;

%Set label font sizes
d.fsize = 18;

%

%Get parameters from GUI
d.eqa1 = get( d.h.EDITeqa1,'string' );
d.eqa2 = get( d.h.EDITeqa2,'string' );
d.eqa3 = get( d.h.EDITeqa3,'string' );
d.eqa4 = get( d.h.EDITeqa4,'string' );
d.eqa5 = get( d.h.EDITeqa5,'string' );
d.eqa1_show = get( d.h.CHECKeqa1,'value' );
d.eqa2_show = get( d.h.CHECKeqa2,'value' );
d.eqa3_show = get( d.h.CHECKeqa3,'value' );
d.eqa4_show = get( d.h.CHECKeqa4,'value' );
d.eqa5_show = get( d.h.CHECKeqa5,'value' );
d.xmin = str2num( get( d.h.EDITxmin,'string') );
d.ymin = str2num( get( d.h.EDITymin,'string') );
d.xmax = str2num( get( d.h.EDITxmax,'string') );
d.ymax = str2num( get( d.h.EDITymax,'string') );
d.xtick = str2num( get( d.h.EDITxtick,'string') );
d.ytick = str2num( get( d.h.EDITytick,'string') );
d.xyscale = get( d.h.CHECKxyscale,'value' );

%Generate y data for each equation
[d.x1,d.y1] = fx( get( d.h.EDITeqa1,'string' ),d.xmin,d.xmax,d.ymin,d.ymax,d.N);
[d.x2,d.y2] = fx( get( d.h.EDITeqa2,'string' ),d.xmin,d.xmax,d.ymin,d.ymax,d.N);
[d.x3,d.y3] = fx( get( d.h.EDITeqa3,'string' ),d.xmin,d.xmax,d.ymin,d.ymax,d.N);
[d.x4,d.y4] = fx( get( d.h.EDITeqa4,'string' ),d.xmin,d.xmax,d.ymin,d.ymax,d.N);
[d.x5,d.y5] = fx( get( d.h.EDITeqa5,'string' ),d.xmin,d.xmax,d.ymin,d.ymax,d.N);

%Plot graphs
axes(d.h.AXESgraph);
cla;
plot_graph;

%Save settings
save settings d

%%

%Plot graph
function plot_graph
global d

hold off
p=plot( d.x1, d.y1, 'r','linewidth',2 );
if d.eqa1_show == 0; delete(p); end
hold on
if d.eqa2_show == 1; plot( d.x2, d.y2, 'b','linewidth',2  ); end
if d.eqa3_show == 1; plot( d.x3, d.y3, 'g','linewidth',2  ); end
if d.eqa4_show == 1; plot( d.x4, d.y4, 'm','linewidth',2  ); end
if d.eqa5_show == 1; plot( d.x5, d.y5, 'k','linewidth',2  ); end

%Plot x and y axis
plot( [d.xmin,d.xmax],[0,0],'k','linewidth',3 )
plot( [0,0], [d.ymin,d.ymax],'k','linewidth',3 )

%Set equi-spaced grid and fix limits
if d.xyscale==1
    axis equal
end
set(d.h.AXESgraph,'fontsize',d.fsize);
xlim( [d.xmin,d.xmax] );
ylim( [d.ymin,d.ymax] );
xlabel('x','fontsize',d.fsize)
ylabel('y','fontsize',d.fsize)

%Determine tick marks for grid
yticks = roundn(d.ymin,1) : roundn(d.ytick,1) : roundn(d.ymax,1);
xticks = roundn(d.xmin,1) : roundn(d.xtick,1) : roundn(d.xmax,1);
set( gca, 'xtick',xticks,'ytick',yticks );
grid on

%%

%Round to n decimal places
function x = roundn(x,n)
x = x*10^n;
x = round(x);
x = x*10^-n;

%%

%Set values to be NaN if imaginary parts detected
function y = imag_check(x)
im_tol = 1e-6;
ok = find( ( abs( imag(x) ) < im_tol ) );
y = NaN(size(x));
y(ok) = real( x(ok) );

%%

% y = f(x), based on string s
function [x,y] = fx(s,xmin,xmax,ymin,ymax,N)

%Determine default x vector
x = linspace( xmin, xmax, N );

%Check string s for blank inputs, or constant inputs.
if isempty(s)==1
    s = 'y=0*x';
elseif isempty( strfind( s, 'x' ) ) == 1
    %s is of the form y = constant
    s = [s,'*ones(size(x))']; 
elseif isempty( strfind( s, 'y' ) ) == 1
    %s is of the form x = constant
    eval([s,';']); x = x*ones(1,N);
    s = 'y = linspace(ymin,ymax,N)';
end

%Force element-wise multiplication (since x is a vector)
s = strrep(s,'^','.^');
s = strrep(s,'/','./');
s = strrep(s,'*','.*');
s = [s,';'];

%Evaluate elements of vector y
eval(s);

%Make any imaginary parts NaN
y = imag_check(y);

%%

%Centre figure in screen
function figcentre(fig)

%Get screen dimensions in pixels.
set(0,'units','pixels') ;
screen_size=get(0,'Screensize');

%Get original figure units
orig_units = get(fig,'units');

%Get position vector for figure in pixels
set(fig,'units','pixels');
fig_position=get(gcf,'position') ;

%Define coordinates or figure bottom hand corner from screen bottom hand corner
%that will place the figure window in the center of the screen.
centre_x = 0.5*screen_size(3) - 0.5*fig_position(3);
centre_y = 0.5*screen_size(4) - 0.5*fig_position(4);

%Modify figure position to centre
set(fig,'position',[centre_x,centre_y,fig_position(3),fig_position(4)] );

%Reset figure units
set(fig,'units',orig_units);

%End of code

