% XXXX
% A MATLAB GUI template. This includes most of the basic GUI
% functionality. Start new GUI projects from this template!
%
% LAST UPDATED by Andy French. February 2015.
%
% Basic Instructions for making new GUIs in MATLAB:
%
% 1. Create a new project directory and copy files XXXX.m, XXXX.fig
% and the sub-directory XXXX to this directory.
%
% 2. Decide on a name for the GUI. Make sure this has no spaces. Rename
% all instances of XXXX to this name. You will need to change the .m and
% .fig filenames, the directory first.
% Then open the .m files and do a Find & Replace on XXXX to the new project
% name. Don't use a pre-existing MATLAB function like 'find' or 'image' !!
%
% 3. In the command window type 'guide <new project name which matches the
% .m file > and modify the GUI elements as required. You will need to
% change the Callback property code from something like:
%
% XXXX('PUSHloadtext_Callback',hObject,eventdata,guidata(hObject))
%
% replacing the XXXX with your new project name, and the GUI element Tag,
% 'PUSHloadtext' in this case, to the Tag property of the GUI if this is to
% be changed.
%
% 4.  Place any sub-functions, .mat files etc to be called by XXXX.m in the
% XXXX folder (or whatever you choose to name it as!)
%
% HELPFUL HINTS:
%
% 1. Make sure the .fig file properties are set to generate .fig file only.
% This will prevent MATLAB changing your .m file when you modify the GUI in
% guide.
%
% 2. Always use units of pixels for GUI objects. If you don't do this, you
% will find GUI's may look strange when you change screen size, move from
% desktop to laptop etc.
%
% 3. Use a sensible naming convention for Tags of GUI objects and their
% Callback functions. e.g. PUSHloadtext, TOGGLEplay, MENUchoosecolourscheme

%%%% GUI INITIALIZATION %%%%

%Top level GUI initialization
function varargout = XXXX(varargin)

% Generic MATLAB GUI initialization. Edit at your peril!
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @XXXX_OpeningFcn, ...
    'gui_OutputFcn',  @XXXX_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

%%

% Outputs from this function are returned to the command line.
function varargout = XXXX_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;

%%

% Code which executes just before XXXX is made visible.
function XXXX_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for XXXX
handles.output = hObject;
guidata(hObject, handles);

%Add all subdirectories within current directory to MATLAB path
addpath( genpath(pwd), '-begin');

%Store GUI object handles data in a global array d which can be seen (and
%modified) by all functions. This will be the main GUI data array which
%enables all objects to communicate with one another.
global d
d.h = handles; clear handles

%Centre figure
figcentre(d.h.FIGUREXXXX);

%Add key-press handler to figure and close-request function. The code for
%these operations is to be found later in this file. Also add mouse button event
%controls (click down, drag, click up etc) to figure.
set( d.h.FIGUREXXXX,...
    'KeyPressFcn',@keypressfunc,...
    'KeyReleaseFcn',@keyreleasefunc,...
    'CloseRequestFcn',@closerequestfunc,...
    'WindowButtonDownFcn',@mouseclickdown,...
    'WindowButtonMotionFcn',@mousedrag,...
    'WindowButtonUpFcn',@mouseclickup,...
    'WindowScrollWheelFcn',@mousewheelscroll );

%Set figure renderer
set( d.h.FIGUREXXXX,'renderer','painters');

%Set default name for GUI
d.name = 'MATLAB GUI template XXXX';
set( d.h.FIGUREXXXX,'name',d.name);

%Initialize info bar
set( d.h.TEXTinfobar,'string', 'Welcome to MATLAB GUI demo XXXX' );

%Initialize AXES and set axes units to be pixels and set the axes
%outerposition to be the same as the plotting region.
axes(d.h.AXES); axis off;
set( d.h.AXES,'Nextplot','add','units','pixels');
axis equal

%Initialize mouse parameters
d.mouse.x = [];
d.mouse.y = [];
d.mouse.within_axes = 0;
d.mouse.button = 'not clicked';

%Initialize text loader parameters
d.text.filename = '';
d.text.word_count = 0;
d.text.text = [];

%Initialize image loader parameters
d.image.filename = '';
d.image.image = [];
d.image.image_handle = [];

%Initalize menu options for image colour scheme
d.image.colour_scheme_menu = {
    'Normal full colour',...
    'Grayscale',...
    'Inverted'
    };
d.image.colour_scheme_menu_option = 1;
d.image.colour_scheme =...
    d.image.colour_scheme_menu{ d.image.colour_scheme_menu_option };
set( d.h.MENUchoosecolourscheme,...
    'string',d.image.colour_scheme_menu, ...
    'value',d.image.colour_scheme_menu_option );

%Initialize music player parameters
d.music.play = 0;
d.music.reverse = 0;
d.music.update_time_s = 0.1;
d.music.filename = '';
d.music.music = [];
d.music.sample_rate_Hz = 0;
d.music.duration_s = 0;
d.music.audioplayer_obj = [];

%Initialize sound recorder parameters
d.music.audiorecorder_obj = [];
d.music.myRecording = [];
d.music.recorded_sample_rate_Hz = [];
d.music.recorded_audioplayer_obj = [];

%Initialize GUI parameters for music aspects
set( d.h.TOGGLEplay,'value',0 );
set( d.h.TOGGLEreverse,'value',0 );

%%

%%% GUI CALLBACK FUNCTIONS %%%%

%%% TEXT %%%

% Load text file pushbutton. This brings up the standard windows file
% window. The filename of the selected file is displayed in the GUI and the
% file contents stored in d.text.text
function PUSHloadtext_Callback(hObject, eventdata, handles)
global d

%Bring up a windows file browser
[filename, pathname] = uigetfile('*.txt', 'Choose text file to load');
if filename ~=0
    %Store the filename in the GUI data
    d.text.filename = [pathname,filename];
    
    %Start clock and display loading message to the infobar
    t0 = tic;
    set( d.h.TEXTinfobar,'string',['Loading file: ',d.text.filename,' ...'] );
    drawnow;
    
    %Update the edit box with the filename only
    set( d.h.EDITloadtext, 'string', filename );
    
    %Open file filename (read only)
    fid = fopen( d.text.filename, 'r' );
    
    %Store filename text in a row vector of ASCII characters
    d.text.text = fscanf(fid, '%c');
    
    %Close file
    fclose(fid); clear fid
    
    %Update 'String' property of listbox LISTtext
    set( d.h.LISTtext, 'string', string_vector2cell( d.text.text ) );
    
    %Count words and update appropriate edit box
    set( d.h.EDITwordcount,'string',num2str( wordcount( d.text.text ) ) );
    
    %Display loading completion message to info bar
    set( d.h.TEXTinfobar,'string',['File: ',d.text.filename,' loaded in ',num2str(toc(t0)),' seconds.'] );
end

%%

% Open loaded text file externally to MATLAB using the default Windows
% program for the .txt file extension
function PUSHtextopen_Callback(hObject, eventdata, handles)
global d

%Open file using default windows program
if strcmp( d.text.filename,'') ~=1
    winopen( d.text.filename );
end

%%

%List box which displays the loaded text
function LISTtext_Callback(hObject, eventdata, handles)
global d
%Test for scroll function. For list scroll bar to modify the value
%property, it seems as if one has to click on a new line in the list box
%first.
v = get( d.h.LISTtext,'value' );

%%

%%% IMAGE %%%

% Load image file (e.g .jpg, .png etc) pushbutton
function PUSHloadimage_Callback(hObject, eventdata, handles)
global d

%Bring up a windows file browser
[filename, pathname] = uigetfile( {'*.jpg;*.png;*.bmp'}, 'Choose image file to load');

%Only proceed if file selected ...
if filename ~=0
    
    %Delete any previous image
    delete( d.image.image_handle );
    
    %Store the filename in the GUI data
    d.image.filename = [pathname,filename];
    
    %Update the edit box with the filename only
    set( d.h.EDITloadimage, 'string', filename );
    
    %Load the image
    d.image.image = flipdim( imread( d.image.filename ), 1 );
    
    %Apply desired basic image procesing
    RGB_output = basic_image_processing( d.image.image , d.image.colour_scheme );
    
    %Create an image object to display the image. Store the start and stop
    %pixels of the x,y coordinates of the image frame to enable it to be
    %moved around when dragging the mouse.
    d.image.image_handle = image( RGB_output );
    d.image.xdata = get( d.image.image_handle,'xdata');
    d.image.ydata = get( d.image.image_handle,'ydata');
    axis image
    axis manual;
end

%%

% Open loaded image file externally to MATLAB using the default Windows
% program for the bitmap image file extension
function PUSHimageopen_Callback(hObject, eventdata, handles)
global d

%Open file using default windows program
if strcmp( d.image.filename,'') ~=1
    winopen( d.image.filename );
end

%%

%Pop-up menu for the image colour scheme
function MENUchoosecolourscheme_Callback(hObject, eventdata, handles)
global d

%Get selected option and update the entries in d.image
d.image.colour_scheme_menu_option = get( d.h.MENUchoosecolourscheme, 'value' );
d.image.colour_scheme =...
    d.image.colour_scheme_menu{ d.image.colour_scheme_menu_option };

%Apply desired basic image procesing
RGB_output = basic_image_processing( d.image.image , d.image.colour_scheme );

%Display the image to the AXES
set( d.image.image_handle,'CData',RGB_output);

%%

%%% MUSIC %%%

% Pushbutton which loads a .mp3 or .wav music file. This brings up the
% standard windows file window. The filename of the selected file is
% displayed in the GUI and the file contents stored in d.music.music
function PUSHloadmusic_Callback(hObject, eventdata, handles)
global d

%Bring up a windows file browser
[filename, pathname] = uigetfile({'*.mp3;*.wav'}, 'Choose .mp3 or .wav file to load');
if filename ~=0
    
    %Clear any previous audioplayer object
    if ~isempty( d.music.audioplayer_obj )
        stop( d.music.audioplayer_obj );
        delete(d.music.audioplayer_obj)
    end
    
    %Store the filename in the GUI data
    d.music.filename = [pathname,filename];
    
    %Update the edit box with the filename only
    set( d.h.EDITloadmusic, 'string', filename );
    
    %Start clock and display loading message to the infobar
    t0 = tic;
    set( d.h.TEXTinfobar,'string',['Loading file: ',d.music.filename,' ...'] );
    drawnow;
    
    %Load music file
    if strcmp( filename( end-3 : end ), '.mp3' )
        [d.music.music,d.music.sample_rate_Hz,Nbits] = mp3read( d.music.filename );
    elseif strcmp( d.filename( end-3 : end ), '.wav' )
        if exist('audioread.m')==0
            [d.music.music,d.music.sample_rate_Hz,Nbits] = wavread( d.music.filename );
        else
            [d.music.music,d.music.sample_rate_Hz] = audioread( d.music.filename );
            info = audioinfo(filename);
            Nbits = info.BitsPerSample;
        end
    end
    
    %Convert to Stereo if .wav file is Mono
    dim = size(d.music.music);
    if dim(2)==1
        d.music.music = [d.music.music,d.music.music ];
    end
    
    %Create audioplayer object from music file
    if d.music.reverse == 1;
        %Reverse music if option set
        m = flipdim(d.music.music,1);
    else
        m = d.music.music;
    end
    d.music.audioplayer_obj = audioplayer( m, d.music.sample_rate_Hz );
    play( d.music.audioplayer_obj );
    pause( d.music.audioplayer_obj );
    
    %Play is option set
    if d.music.play == 1
        resume( d.music.audioplayer_obj );
    end
    
    %Compute duration of waveform /s
    d.music.duration_s = dim(1)/d.music.sample_rate_Hz;
    
    %Display loading completion message to info bar
    set( d.h.TEXTinfobar,'string',['File: ',d.music.filename,' loaded in ',num2str(toc(t0)),' seconds.'] );
end

%%

%Load music file into the default Windows program
function PUSHmusicopen_Callback(hObject, eventdata, handles)
global d

%Open file using default windows program
if strcmp( d.music.filename,'') ~=1
    winopen( d.music.filename );
end

%%

%Toggle button which plays any music loaded. It toggles between a play and
%pause status.
function TOGGLEplay_Callback(hObject, eventdata, handles)
global d

%Manage play or not play toggle status
if d.music.play == 1
    d.music.play = 0;
    set( d.h.TOGGLEplay,'value',0 );
    set( d.h.TOGGLEplay,'BackGroundColor',[0.941,0.941,0.941] );
    if ~isempty( d.music.audioplayer_obj )
        pause( d.music.audioplayer_obj );
    end
else
    
    %Play music
    d.music.play = 1;
    set( d.h.TOGGLEplay,'value',1 );
    set( d.h.TOGGLEplay,'BackGroundColor',[0,1,0] );
    
    %Check if any music has been loaded
    if ~isempty( d.music.audioplayer_obj )
        resume( d.music.audioplayer_obj );
    end
end

%%

%Toggle button which regenerates an audioplayer object, but using the sound
%samples in d.music.music played in reverse!
function TOGGLEreverse_Callback(hObject, eventdata, handles)
global d

%Manage reverse or not reverse toggle status
if d.music.reverse == 1
    d.music.reverse = 0;
    set( d.h.TOGGLEreverse,'value',0 );
    set( d.h.TOGGLEreverse,'BackGroundColor',[0.941,0.941,0.941] );
else
    d.music.reverse = 1;
    set( d.h.TOGGLEreverse,'value',1 );
    set( d.h.TOGGLEreverse,'BackGroundColor',[1,0.1,0.1] );
end

%If some music has already been loaded ....
if ~isempty( d.music.audioplayer_obj )
    
    %Clear any previous audioplayer object
    stop( d.music.audioplayer_obj );
    delete(d.music.audioplayer_obj)
    
    %Create audioplayer object from music file;
    if d.music.reverse == 1;
        %Reverse music if option set
        m = flipdim(d.music.music,1);
    else
        m = d.music.music;
    end
    
    %Recreate audioplayer object
    d.music.audioplayer_obj = audioplayer( m, d.music.sample_rate_Hz );
    play( d.music.audioplayer_obj );
    pause( d.music.audioplayer_obj );
    
    %Play is option set
    if d.music.play == 1
        resume( d.music.audioplayer_obj );
    end
end

%%

%Music restart pushbutton. This stops the current audioplayer object
%and then, if the play toggle is pressed, plays the music in d.music.music
%from the beginning.
function PUSHrestart_Callback(hObject, eventdata, handles)
global d
if ~isempty( d.music.audioplayer_obj )
    stop( d.music.audioplayer_obj );
    if d.music.play == 1;
        play( d.music.audioplayer_obj );
    end
end

%%

%Pushbutton which initiates a five second sound recording (following a 5
%second countdown with GUI feedback). The sound recording is then played
%back.
function PUSHrecord_Callback(hObject, eventdata, handles)
global d

%Countdown time /s
countdown_time_s = 5;

%Recording time /s
recording_time_s = 5;

%Sample rate /Hz
d.music.recorded_sample_rate_Hz = 44100;

%Number of bits and channels
nBits = 16;
nChannels = 2;

%

%Change colour of push button and initiate countdown
set( d.h.PUSHrecord,'backgroundcolor', [1,0,0] );
set( d.h.PUSHrecord,'string',[ 'Recording in ',num2str(countdown_time_s), ' seconds ...' ] );
for n=1:ceil(countdown_time_s)
    pause(1);
    set( d.h.PUSHrecord,'string',[ 'Recording in ',...
        num2str(ceil( countdown_time_s ) - n), ' seconds ...' ] );
end

%Display 'RECORDING...' message
set( d.h.PUSHrecord,'string',[ 'RECORDING for ',num2str(recording_time_s), ' seconds ...' ] );

%Create audiorecorder object
d.music.audiorecorder_obj = audiorecorder( d.music.recorded_sample_rate_Hz,nBits,nChannels );

%Make a recording using the deault sound recorder system (e.g. webcam,
%microphone in etc)
recordblocking( d.music.audiorecorder_obj, recording_time_s );

%Restore string of pushbutton and background colour
set( d.h.PUSHrecord, 'string', 'Record sound for five seconds and then play it back' );
set( d.h.PUSHrecord,'backgroundcolor', [0,1,0] );

%Store data in double-precision array.
d.music.myRecording = getaudiodata(d.music.audiorecorder_obj);

%Generate audioplayer object from sound smaples
d.music.recorded_audioplayer_obj = audioplayer( d.music.myRecording, d.music.recorded_sample_rate_Hz );
play( d.music.recorded_audioplayer_obj );

% Plot the waveform in a new figure window
figure('color',[1 1 1],'name', 'Audio recording')
dim = size(d.music.myRecording);
t = linspace( 0, (dim(1) - 1)/d.music.recorded_sample_rate_Hz, dim(1) ).'; 
subplot(2,1,1);
plot( t, d.music.myRecording(:,1),'r' );
ylabel('Signal amplitude')
title('Sound recording: Left channel')
grid on
subplot(2,1,2);
plot( t, d.music.myRecording(:,2),'b' );
xlabel( 'Time /s')
ylabel('Signal amplitude')
title('Sound recording: Right channel')
grid on

%%

%Play back recorded waveform
function TOGGLEplayrecorded_Callback(hObject, eventdata, handles)
global d

%Check if any sound has been recorded
if ~isempty( d.music.myRecording );
 
    %Get GUI toggle status, play or pause accordingly
    if get( d.h.TOGGLEplayrecorded, 'value' ) == 1
        resume(d.music.recorded_audioplayer_obj);
        set( d.h.TOGGLEplayrecorded,'backgroundcolor',[0,1,0] );
    else
        pause(d.music.recorded_audioplayer_obj);
        set( d.h.TOGGLEplayrecorded,'backgroundcolor',[0.941,0.941,0.941] );
    end   
end

%%

%%%% KEYBOARD & MOUSE INTERACTION CALLBACKS %%%%

% e.g. key press handler, mouse click event manager,
% close request function etc

%Key press handler
function keypressfunc(hObject, eventdata, handles)
global d

%Get the string of the current key press
s = get( d.h.FIGUREXXXX,'currentkey');

%Actions, depending on the key pressed...

if ( strcmp(s,'q') == 1 ) || ( strcmp(s,'Q') == 1 )
    %Quit GUI
    closerequestfunc;
elseif ( strcmp(s,'t') == 1 ) || ( strcmp(s,'T') == 1 )
    %Load text file
    PUSHloadtext_Callback;
elseif ( strcmp(s,'m') == 1 ) || ( strcmp(s,'M') == 1 )
    %Load music file
    PUSHloadmusic_Callback;
elseif ( strcmp(s,'i') == 1 ) || ( strcmp(s,'I') == 1 )
    %Load image file
    PUSHloadimage_Callback;
elseif ( strcmp(s,'p') == 1 ) || ( strcmp(s,'P') == 1 )
    %Play music
    TOGGLEplay_Callback;
elseif ( strcmp(s,'r') == 1 ) || ( strcmp(s,'R') == 1 )
    %Reverse playback of music
    TOGGLEreverse_Callback
elseif ( strcmp(s,'b') == 1 ) || ( strcmp(s,'B') == 1 )
    %Restart music player from beginning of track
    PUSHrestart_Callback
end

%%

%Key release handler
function keyreleasefunc(hObject, eventdata, handles)
global d

%%

%This function executes when the mouse is clicked
function mouseclickdown(hObject, eventdata, handles)
global d

%Get click-type
d.mouse.clicktype = get(d.h.FIGUREXXXX, 'SelectionType');

%Double left mouse button click
if strcmp(d.mouse.clicktype,'open')==1
    d.mouse.button = 'double click';
    
    %Single left mouse click
elseif strcmp(d.mouse.clicktype,'normal')==1
    d.mouse.button = 'single click';
    
    %Shift + click or right & left mouse click
elseif strcmp(d.mouse.clicktype,'extend')==1
    d.mouse.button = 'shift & click';
    
    %Control + click or right mouse click
elseif strcmp(d.mouse.clicktype,'alt')==1
    d.mouse.button = 'ctrl & click';
else
    d.mouse.button = 'not clicked';
end

%Store 'click point' coordinates (pixels from bottom left of the figure)
cp=get( d.h.FIGUREXXXX,'currentpoint');
d.mouse.x = cp(1,1);
d.mouse.y = cp(1,2);

%Check 'click point' coordinates are within axes
ax_pos = get( d.h.AXES, 'position' );
xv = [ ax_pos(1), ax_pos(1)+ax_pos(3), ax_pos(1)+ax_pos(3), ax_pos(1) ];
yv = [ ax_pos(2), ax_pos(2), ax_pos(2) + ax_pos(4), ax_pos(2) + ax_pos(4) ];
d.mouse.within_axes = inpolygon( d.mouse.x, d.mouse.y, xv, yv );

%Randomly change colours of image if right mouse button is clicked
if ( d.mouse.within_axes == 1) && ( strcmp( d.mouse.button, 'ctrl & click' ) )
    %Apply desired basic image procesing
    RGB_output = basic_image_processing( d.image.image , 'random' );
    
    %Display the image to the AXES
    set( d.image.image_handle,'CData',RGB_output);
    
end

%%

%This function runs when a mouse is dragged following a click event, and
%before the mouse button is released
function mousedrag(hObject, eventdata, handles)
global d

%Store 'click point' coordinates (pixels from bottom left of the figure)
cp=get( d.h.FIGUREXXXX,'currentpoint');
x = cp(1,1);
y = cp(1,2);

%Determine pixel displacement from click point
dx = x - d.mouse.x;
dy = y - d.mouse.y;

%Move image if mouse was originally clicked within AXES, and indeed an
%image was loaded to enable an image object to be created
if ( d.mouse.within_axes==1 ) && ( ~isempty( d.image.image_handle ) )
    set( d.image.image_handle, 'Xdata', d.image.xdata + dx );
    set( d.image.image_handle, 'Ydata', d.image.ydata + dy );
    set( d.h.FIGUREXXXX,'name','....dynamically moving image with the mouse!');
    drawnow;
end

%%

%This function executes when a mouse button is released
function mouseclickup(hObject, eventdata, handles)
global d

%Reset mouse parameters
d.mouse.within_axes = 0;
d.mouse.button = 'not clicked';

%Update position data of image object
d.image.xdata = get( d.image.image_handle,'xdata');
d.image.ydata = get( d.image.image_handle,'ydata');

%Reset name of GUI to default
set( d.h.FIGUREXXXX,'name',d.name);

%Apply desired basic image procesing
RGB_output = basic_image_processing( d.image.image , d.image.colour_scheme );

%Display the image to the AXES
set( d.image.image_handle,'CData',RGB_output);

%%

%This function executes when the mouse scroll wheel is used
function mousewheelscroll(hObject, eventdata, handles)
global d

if ( d.mouse.within_axes==1 ) && ( ~isempty( d.image.image_handle ) )
    %Zoom in on image if it has already been clicked (and possibly dragged) via
    %scroll of mouse wheel
    if eventdata.VerticalScrollCount > 0
        zoom( 1 + eventdata.VerticalScrollCount/10 );
    elseif eventdata.VerticalScrollCount < 0
        zoom( 1/ (1 - eventdata.VerticalScrollCount/10 ) );
    end
    
elseif ~isempty( d.text.text )
    %Otherwise scroll through the text file displayed in the list box.
    %Achieve this by modifying the 'value' property of the list box.
    v = get( d.h.LISTtext,'value' );
    vmax = numel( get( d.h.LISTtext,'string' ) );
    v = v + eventdata.VerticalScrollCount ;
    if v<0
        v=0;
    elseif v>vmax
        v=1;
    end
    set(  d.h.LISTtext,'value' ,v );
end

%%

%GUI close function
function closerequestfunc(hObject, eventdata, handles)
global d

%Close GUI
delete( d.h.FIGUREXXXX );

%Stop any music playing and clear any previous audioplayer object
if ~isempty( d.music.audioplayer_obj )
    stop( d.music.audioplayer_obj );
    delete(d.music.audioplayer_obj)
    stop( d.music.recorded_audioplayer_obj );
    delete(d.music.audioplayer_obj);
    delete(d.music.audiorecorder_obj);
end

%Remove sub-directories within current directory from MATLAB path
rmpath( genpath(pwd) );

%

%%%% OTHER FUNCTIONS %%%

% It might be best to have these as separate .m files with corresponding
% test scripts or functions. If so store them in the XXXX directory or
% equivalent. However, if you only want to have a .m file and .fig file
% pair, store supplementary function code here.

%

% Function which converts a vector of ASCII text s to a cell array c, with each
% element being a different line of the ASCII text
function c = string_vector2cell(s)

%Initialize output cell array and element number i
c{1} = '';
i = 1;

%Step through text file and add to appropriate elements of c
for n=1:length(s)
    c{i} = [c{i},s(n)];
    if ( strcmp( s(n), char(10) ) == 1) ||...
            ( strcmp( s(n), char(13) ) == 1) ||...
            ( strcmp( s(n), char(15) ) == 1)
        i = i + 1;
        c{i} = '';
    end
end

%%

% Function which counts words within an ASCII string vector s. It does this
% quite crudely by counting the number of spaces.
function w = wordcount(s)
if isempty(s)
    w=0;
else
    %Work out the number of instances of the space ' ' character in s
    w = length( strfind( s, ' ') ) - 1;
    if w<=0;
        %If there are no spaces but s is not empty, we can presume s
        %contains a single word
        w=1;
    end
end

%%

% Function which applies some very basic image processing to an RGB
% colour array RGB. Options are:
% 'Convert to grayscale' or 'Invert colours'
% Assume RGB is either an MxN or MxNx1 (grayscale) or an MxNx3 (full
% colour) matrix of element values between 0 and 255.
function RGB_output = basic_image_processing( RGB , processing_option )

%Check if input is empty
if ~isempty(RGB)
    
    %Initialise output
    dim = size(RGB);
    RGB_output = zeros( dim(1),dim(2),3,'uint8' );
    
    %
    
    %Grayscale colour processing option
    if strcmp( processing_option, 'Grayscale' )
        
        %Check if the image is not already Grayscale
        %If it is then there will only be one colour matrix corresponding to
        %intensity of white.
        if numel(dim)==3
            if dim(3) == 3
                %Image is full colour, so average the intensity over Red, Green
                %and Blue colour planes to make a grayscale image. I shall
                %use a Luminosity method from the GIMP, which accounts for
                %human perception of green being much stronger than red,
                %and certainly blue colours.
                % http://www.johndcook.com/blog/2009/08/24/algorithms-convert-color-grayscale/
                RGB_output(:,:,1) =  0.21*RGB(:,:,1) + 0.72*RGB(:,:,2) + 0.07*RGB(:,:,3);
                RGB_output(:,:,2) = RGB_output(:,:,1);
                RGB_output(:,:,3) = RGB_output(:,:,1);
            else
                %Image is already grayscale but not a MxNx3 matrix
                RGB_output(:,:,1) = RGB(:,:,1);
                RGB_output(:,:,2) = RGB_output(:,:,1);
                RGB_output(:,:,3) = RGB_output(:,:,1);
            end
        else
            %Image is already grayscale but not a MxNx3 matrix
            RGB_output(:,:,1) = RGB(:,:);
            RGB_output(:,:,2) = RGB_output(:,:,1);
            RGB_output(:,:,3) = RGB_output(:,:,1);
        end
        
        %
        
        %Inverted colour processing option
    elseif strcmp( processing_option, 'Inverted' )
        
        %Check if the image is not already Grayscale
        %If it is then there will only be one colour matrix corresponding to
        %intensity of white.
        dim = size(RGB);
        if numel(dim)==3
            if dim(3) == 3
                %Image is full colour, so process colour
                %planes separately
                RGB_output(:,:,1) = 255 - RGB(:,:,1);
                RGB_output(:,:,2) = 255 - RGB(:,:,2);
                RGB_output(:,:,3) = 255 - RGB(:,:,3);
            else
                %Image is already grayscale but not a MxNx3 matrix
                RGB_output(:,:,1) = 255 - RGB(:,:,1);
                RGB_output(:,:,2) = RGB_output(:,:,1);
                RGB_output(:,:,3) = RGB_output(:,:,1);
            end
        else
            %Image is already grayscale but not a MxNx3 matrix
            RGB_output(:,:,1) = 255 - RGB(:,:);
            RGB_output(:,:,2) = RGB_output(:,:,1);
            RGB_output(:,:,3) = RGB_output(:,:,1);
        end
        
        %
        
        %Random colour processing option
    elseif strcmp( processing_option, 'random' )
        
         %Check if the image is not already Grayscale
        %If it is then there will only be one colour matrix corresponding to
        %intensity of white.
        dim = size(RGB);
        if numel(dim)==3
            if dim(3) == 3
                %Image is full colour, so process colour
                %planes separately. Randomly swap colour planes
                RGB_output(:,:,1) = RGB(:,:,randi(3,1));
                RGB_output(:,:,2) = RGB(:,:,randi(3,1));
                RGB_output(:,:,3) = RGB(:,:,randi(3,1));
            else
                %Image is already grayscale but not a MxNx3 matrix
                %In this case invert
                RGB_output(:,:,1) = 255 - RGB(:,:,1);
                RGB_output(:,:,2) = RGB_output(:,:,1);
                RGB_output(:,:,3) = RGB_output(:,:,1);
            end
        else
            %Image is already grayscale but not a MxNx3 matrix
            %In this case invert
            RGB_output(:,:,1) = 255 - RGB(:,:);
            RGB_output(:,:,2) = RGB_output(:,:,1);
            RGB_output(:,:,3) = RGB_output(:,:,1);
        end      
    else
        
        %
        
        %Do nothing!
        RGB_output = RGB;
    end
    
    %
    
    
else
    %Do nothing!
    RGB_output = RGB;
end

%%

%figcenter
% Centres a figure with handle fig in the current display.
%
% LAST UPDATED by Andy French Feb 2015

function figcentre(fig)

%Get screen dimensions in pixels.
set(0,'units','pixels') ;
screen_size=get(0,'Screensize');
display_size=get(0,'MonitorPositions');

%Get original figure units
orig_units = get(fig,'units');

%Get position vector for figure in pixels
set(fig,'units','pixels');
fig_position=get(gcf,'position') ;

%Define coordinates or figure bottom hand corner from screen bottom hand corner
%that will place the figure window in the center of the screen.
centre_x = 0.5*( screen_size(3)-fig_position(3) ) - screen_size(1);
centre_y = 0.5*( screen_size(4)-fig_position(4) ) - screen_size(2);

%Modify figure position to centre
set(fig,'position',[centre_x,centre_y,fig_position(3),fig_position(4)] );

%Reset figure units
set(fig,'units',orig_units);

%End of code
