%gradientor
% A simple graphing app which calculates and plots the tangent and gradient
% to two user specified curves.
% LAST UPDATED by Andy French. January 2014.

function varargout = gradientor(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @gradientor_OpeningFcn, ...
    'gui_OutputFcn',  @gradientor_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%%

function gradientor_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for gradientor
handles.output = hObject;

%Centre figure
figcentre(gcf);

% Update handles structure and store into structure d.h within global
% variable d
guidata(hObject, handles);
global d

%Load d from previous settings
try
    load settings
    d.h = handles;
    
    %Update the GUI with settings data
    set( d.h.EDITeqa1,'string',d.eqa1 );
    set( d.h.EDITeqa2,'string',d.eqa2 );
    set( d.h.EDITeqa1tangent,'string',d.y1_tangent_eqa );
    set( d.h.EDITeqa1normal,'string',d.y1_normal_eqa );
    set( d.h.EDITeqa2tangent,'string',d.y2_tangent_eqa );
    set( d.h.EDITeqa2normal,'string',d.y2_normal_eqa );
    set( d.h.EDITeqa1tangentx,'string',num2str(d.eqa1tangentx ));
    set( d.h.EDITeqa1normalx,'string',num2str(d.eqa1normalx ));
    set( d.h.EDITeqa2tangentx,'string',num2str(d.eqa2tangentx ));
    set( d.h.EDITeqa2normalx,'string',num2str(d.eqa2normalx ));
    set( d.h.CHECKeqa1,'value',d.eqa1_show );
    set( d.h.CHECKeqa2,'value',d.eqa2_show );
    set( d.h.CHECKeqa1tangent,'value',d.eqa1_tangent_show );
    set( d.h.CHECKeqa1normal,'value',d.eqa1_normal_show );
    set( d.h.CHECKeqa2tangent,'value',d.eqa2_tangent_show );
    set( d.h.CHECKeqa2normal,'value',d.eqa2_normal_show );
    set( d.h.EDITxmin,'string',num2str( d.xmin )) ;
    set( d.h.EDITymin,'string',num2str( d.ymin )) ;
    set( d.h.EDITxmax,'string',num2str( d.xmax )) ;
    set( d.h.EDITymax,'string',num2str( d.ymax )) ;
    set( d.h.EDITxtick,'string',num2str( d.xtick )) ;
    set( d.h.EDITytick,'string',num2str( d.ytick )) ;
    set( d.h.CHECKxyscale,'value',d.xyscale );
catch
    %Store handles array in d.h, and use default settings
    d.h = handles;
end
gui_update;

%%

%Equation 1 edit box callback
function EDITeqa1_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 1 check box callback
function CHECKeqa1_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 1 tangent check box callback
function CHECKeqa1tangent_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 1 normal check box callback
function CHECKeqa1normal_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 1 tangent x edit box callback
function EDITeqa1tangentx_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 1 normal x edit box callback
function EDITeqa1normalx_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 2 edit box callback
function EDITeqa2_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 2 check box callback
function CHECKeqa2_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 2 tangent check box callback
function CHECKeqa2tangent_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 2 normal check box callback
function CHECKeqa2normal_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 2 tangent x edit box callback
function EDITeqa2tangentx_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 2 normal x edit box callback
function EDITeqa2normalx_Callback(hObject, eventdata, handles)
gui_update

%%

% y axis maximum edit box callback
function EDITymax_Callback(hObject, eventdata, handles)
gui_update

%%

% y axis minimum edit box callback
function EDITymin_Callback(hObject, eventdata, handles)
gui_update

%%

% x axis minimum edit box callback
function EDITxmin_Callback(hObject, eventdata, handles)
gui_update

%%

% x axis maximum edit box callback
function EDITxmax_Callback(hObject, eventdata, handles)
gui_update

%%

% xtick edit box callback
function EDITxtick_Callback(hObject, eventdata, handles)
gui_update

%%

% ytick edit box callback
function EDITytick_Callback(hObject, eventdata, handles)
gui_update

%%

% x,y equal scales checkbox callback
function CHECKxyscale_Callback(hObject, eventdata, handles)
gui_update

%%

% Print PNG pushbutton
function PUSHprintPNG_Callback(hObject, eventdata, handles)
fig = figure; ax = axes;
plot_graph;
print(fig,['gradientor ',strrep(datestr(now),':','-')],'-djpeg','-r300');
close(fig);

%%

function varargout = gradientor_OutputFcn(hObject, eventdata, handles)

%%

% GUI update function
function gui_update
global d

%%% Inputs %%%

%Set number of data points
d.N = 2000;

%Set label font sizes
d.fsize = 16;

%

%Get parameters from GUI
d.eqa1 = get( d.h.EDITeqa1,'string' );
d.eqa2 = get( d.h.EDITeqa2,'string' );
d.eqa1tangentx = str2num( get( d.h.EDITeqa1tangentx,'string' ));
d.eqa1normalx = str2num( get( d.h.EDITeqa1normalx,'string' ));
d.eqa2tangentx = str2num( get( d.h.EDITeqa2tangentx,'string' ));
d.eqa2normalx = str2num( get( d.h.EDITeqa2normalx,'string' ));
d.eqa1_show = get( d.h.CHECKeqa1,'value' );
d.eqa2_show = get( d.h.CHECKeqa2,'value' );
d.eqa1_tangent_show = get( d.h.CHECKeqa1tangent,'value' );
d.eqa1_normal_show = get( d.h.CHECKeqa1normal,'value' );
d.eqa2_tangent_show = get( d.h.CHECKeqa2tangent,'value' );
d.eqa2_normal_show = get( d.h.CHECKeqa2normal,'value' );
d.xmin = str2num( get( d.h.EDITxmin,'string') );
d.ymin = str2num( get( d.h.EDITymin,'string') );
d.xmax = str2num( get( d.h.EDITxmax,'string') );
d.ymax = str2num( get( d.h.EDITymax,'string') );
d.xtick = str2num( get( d.h.EDITxtick,'string') );
d.ytick = str2num( get( d.h.EDITytick,'string') );
d.xyscale = get( d.h.CHECKxyscale,'value' );

%Generate y data for each equation
[d.x1,d.y1] = fx( get( d.h.EDITeqa1,'string' ),d.xmin,d.xmax,d.ymin,d.ymax,d.N);
[d.x2,d.y2] = fx( get( d.h.EDITeqa2,'string' ),d.xmin,d.xmax,d.ymin,d.ymax,d.N);

%Determine tangents and normals at the specified values
[y, d.y1_tangent, normal_eqa, d.y1_tangent_eqa] = norm_and_tangent( d.x1, d.y1, d.eqa1tangentx );
[d.y1_normal, y, d.y1_normal_eqa, tangent_eqa] = norm_and_tangent( d.x1, d.y1, d.eqa1normalx );
[y, d.y2_tangent, normal_eqa, d.y2_tangent_eqa] = norm_and_tangent( d.x2, d.y2, d.eqa2tangentx );
[d.y2_normal, y, d.y2_normal_eqa, tangent_eqa] = norm_and_tangent( d.x2, d.y2, d.eqa2normalx );

%Update edit boxes for normals and tangents
if d.eqa1_tangent_show == 1
    set(d.h.EDITeqa1tangent,'string',d.y1_tangent_eqa );
else
    set(d.h.EDITeqa1tangent,'string','' );
end
if d.eqa1_normal_show == 1
    set(d.h.EDITeqa1normal,'string',d.y1_normal_eqa );
else
    set(d.h.EDITeqa1normal,'string','' );
end
if d.eqa2_tangent_show == 1
    set(d.h.EDITeqa2tangent,'string',d.y2_tangent_eqa );
else
    set(d.h.EDITeqa2tangent,'string','' );
end
if d.eqa2_normal_show == 1
    set(d.h.EDITeqa2normal,'string',d.y2_normal_eqa );
else
    set(d.h.EDITeqa2normal,'string','' );
end

%Plot graphs
axes(d.h.AXESgraph);
cla;
plot_graph;

%Save settings
save settings d

%%

%Plot graph
function plot_graph
global d

hold off
p=plot( d.x1, d.y1, 'r','linewidth',2 );
if d.eqa1_show == 0; delete(p); end
hold on
if d.eqa1_tangent_show == 1; plot( d.x1, d.y1_tangent, 'r--','linewidth',2  ); end
if d.eqa1_normal_show == 1; plot( d.x1, d.y1_normal, 'r--','linewidth',2  ); end
if d.eqa2_show == 1; plot( d.x2, d.y2, 'b','linewidth',2  ); end
if d.eqa2_tangent_show == 1; plot( d.x2, d.y2_tangent, 'b--','linewidth',2  ); end
if d.eqa2_normal_show == 1; plot( d.x2, d.y2_normal, 'b--','linewidth',2  ); end

%Plot x and y axis
plot( [d.xmin,d.xmax],[0,0],'k','linewidth',3 )
plot( [0,0], [d.ymin,d.ymax],'k','linewidth',3 )

%Set equi-spaced grid and fix limits
if d.xyscale==1
    axis equal
end
set(d.h.AXESgraph,'fontsize',d.fsize);
xlim( [d.xmin,d.xmax] );
ylim( [d.ymin,d.ymax] );
xlabel('x','fontsize',d.fsize)
ylabel('y','fontsize',d.fsize)

%Determine tick marks for grid
yticks = roundn(d.ymin,1) : roundn(d.ytick,1) : roundn(d.ymax,1);
xticks = roundn(d.xmin,1) : roundn(d.xtick,1) : roundn(d.xmax,1);
set( gca, 'xtick',xticks,'ytick',yticks );
grid on

%%

%Round to n decimal places
function x = roundn(x,n)
x = x*10^n;
x = round(x);
x = x*10^-n;

%%

%Set values to be NaN if imaginary parts detected
function y = imag_check(x)
im_tol = 1e-6;
ok = find( ( abs( imag(x) ) < im_tol ) );
y = NaN(size(x));
y(ok) = real( x(ok) );

%%

% y = f(x), based on string s
function [x,y] = fx(s,xmin,xmax,ymin,ymax,N)

%Determine default x vector
x = linspace( xmin, xmax, N );

%Check string s for blank inputs, or constant inputs.
if isempty(s)==1
    s = 'y=0*x';
elseif isempty( strfind( s, 'x' ) ) == 1
    %s is of the form y = constant
    s = [s,'*ones(size(x))'];
elseif isempty( strfind( s, 'y' ) ) == 1
    %s is of the form x = constant
    eval([s,';']); x = x*ones(1,N);
    s = 'y = linspace(ymin,ymax,N)';
end

%Force element-wise multiplication (since x is a vector)
s = strrep(s,'^','.^');
s = strrep(s,'/','./');
s = strrep(s,'*','.*');
s = [s,';'];

%Evaluate elements of vector y
eval(s);

%Make any imaginary parts NaN
y = imag_check(y);

%%

%Determine equations of tangent and normal based on a set of x,y values.
%The tangent and normal are computed at value xx. s_norm and s_tangent are
%strings of the form 'y = m*x + c.'
function [y_normal, y_tangent, s_normal, s_tangent] = norm_and_tangent( x, y, xx )

%Determine gradient of y(x) at xx
[y_pp,dy_by_dx]=calculus(x,y,xx,'diff','spline',0);

%Interpolate y to find the y value at xx
yy = interp1( x,y, xx, 'spline' );

%Determine tangent equation of the form y = m*x + c
m = dy_by_dx;
c = yy - m*xx;
y_tangent = m*x + c;
s_tangent = ['y = ',num2str(m),'*x + ',num2str(c)];

%Determine normal equation of the form y = n*x + d
n = -1/dy_by_dx;
d = yy - n*xx;
y_normal = n*x + d;
s_normal = ['y = ',num2str(n),'*x + ',num2str(d)];

%%

%CALCULUS
% Function that fits a piecwise polynomial to an array of [X,Y] data and
% thus computes the derivative and cumulative integral of Y(X) at all
% points X. The function is based on the code written on pages 292 and 294
% of "Mastering Matlab 6" by Duane Hanselman & Bruce Littlefield.
%
% LAST UPDATED by Andrew French. 21/09/2004.
%
% Syntax: [Y_pp,Y_calc]=calculus(X,Y,X0,type,poly,C)
%
% X        - Vector of data X variable
% Y        - Vector of data Y(X) variable
% X0       - Vector of X variables corresponding to that of the output.
% type     - 'integ' or 'diff'. Choses integration or diffrentiation of Y(X).
% poly     - 'spline' or 'hermite' . Choses type of piecewise polynomial
%            computed. Hermite polynomials tend to be better for
%            non-smooth data and tends to be 'shape preserving.'
% C        - If type=='integ', this paramater gives the initial value of the
%            integral corresponding to X(1).
%
% Y_pp     - Piecewise polynomial fitted to Y(X) evaluated at X0.
% Y_calc   - Vector of the same dimensions of X0, giving the
%            differential, or integral of Y(X) evaluated at all values of X0.
%
% Example: X=linspace(-2,2,20); Y=X.^2;
% [Y_pp,Y_int]=calculus(X,Y,X,'integ','spline',0);
% [Y_int,YY]=calculus(X,Y_int,X,'diff','spline',0);
% plot(X,Y); hold on;
% plot(X,YY,'g');
% plot(X,Y_pp,'ro');
% legend('Y=X^2','Integral then derivative of Y=X^2','PP fit of Y=X^2');
% xlabel('X'); ylabel('Y');

function [Y_pp,Y_calc]=calculus(X,Y,X0,type,poly,C)

%Compute piecewise polynomial. Cubic spline is the default
if strcmp(poly,'hermite')==1
    pp=pchip(X,Y);
else
    pp=spline(X,Y);
end

%Check if integration or differentiation is required. Differentiation is
%the default option.
if strcmp(type,'integ')==1
    
    %Check that C is a scalar
    if prod(size(C))~=1
        error('C must be a scalar!')
    end
    
    %Take apart piecewise polynomial
    [br,co,npy,nco]=unmkpp(pp);
    
    %Scale factors for integration
    sf=nco:-1:1;
    
    %Integral coefficients
    ico=[co./sf(ones(npy,1),:) zeros(npy,1)];
    
    %Integral spline has higher order
    nco=nco+1;
    
    %Integration constant
    ico(1,nco)=C;
    
    %Find constant terms in polynomials
    for k=2:npy
        ico(k,nco)=polyval(ico(k-1,:),br(k)-br(k-1));
    end
    
    %Build pp form for integral
    ppi=mkpp(br,ico);
    
    %Evaluate integral at values of X0
    Y_calc=ppval(ppi,X0);
    
    %Evaluate piecewise polynomial
    Y_pp=ppval(pp,X0);
else
    
    %Take apart piecewise polynomial
    [br,co,npy,nco]=unmkpp(pp);
    
    %Scale factors for differentiation
    sf=nco-1:-1:1;
    
    %Derivative coefficients
    dco=sf(ones(npy,1),:).*co(:,1:nco-1);
    
    %Build pp form for derivative
    ppd=mkpp(br,dco);
    
    %Evaluate derivative at values of X0
    Y_calc=ppval(ppd,X0);
    
    %Evaluate piecewise polynomial
    Y_pp=ppval(pp,X0);
end

%%

%Centre figure in screen
function figcentre(fig)

%Get screen dimensions in pixels.
set(0,'units','pixels') ;
screen_size=get(0,'Screensize');

%Get original figure units
orig_units = get(fig,'units');

%Get position vector for figure in pixels
set(fig,'units','pixels');
fig_position=get(gcf,'position') ;

%Define coordinates or figure bottom hand corner from screen bottom hand corner
%that will place the figure window in the center of the screen.
centre_x = 0.5*screen_size(3) - 0.5*fig_position(3);
centre_y = 0.5*screen_size(4) - 0.5*fig_position(4);

%Modify figure position to centre
set(fig,'position',[centre_x,centre_y,fig_position(3),fig_position(4)] );

%Reset figure units
set(fig,'units',orig_units);

%End of code

