%insult_gui
% GUI which will randomly generates a Shakesperian insult.
% 
% LAST UPDATED by Andy French. January 2017

function varargout = insult_gui(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @insult_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @insult_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%%

% GUI opening function
function insult_gui_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for insult_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

%Create a global variable d
global d
d.h = handles;

%Load Excel file containing insults
[num,d.txt,raw] = xlsread( 'Shakespearian insults.xlsx' );

%Get dimensions of string array txt
dim = size(d.txt);

%Randomly generate an integer between 1 and number of rows of txt
r = randi( dim(1), 3 );

%Select insults from the three columns of string array txt
%and assemble output string s
s = [ 'Thou ',d.txt{ r(1), 1 },' ',d.txt{ r(2), 2 },' ',d.txt{ r(3), 3 },'!' ];

%Update text box with insult
set( d.h.TEXTinsult,'string',s );

%%

% Outputs from this function are returned to the command line.
function varargout = insult_gui_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
varargout{1} = handles.output;

%%

% Pushbutton which generates a new insult, and updates the GUI
function PUSHinsult_Callback(hObject, eventdata, handles)
global d

%Get dimensions of string array txt
dim = size(d.txt);

%Randomly generate an integer between 1 and number of rows of txt
r = randi( dim(1), 3 );

%Select insults from the three columns of string array txt
%and assemble output string s
s = [ 'Thou ',d.txt{ r(1), 1 },' ',d.txt{ r(2), 2 },' ',d.txt{ r(3), 3 },'!' ];

%Update text box with insult
set( d.h.TEXTinsult,'string',s );

%End of code


