%set_gui_data
% Sets the GUI parameters for julia.m stored in array h

function h = set_gui_data(h)

%Current cell array value corresponding to chosen colourmaps, julia map functions and map creation rules
cmap_val=strmatch( h.J.cmap, h.J.cmaps ,'exact');
map_function_val=strmatch( h.J.map_function, h.J.map_functions, 'exact');
map_creation_rule_val=strmatch( h.J.map_creation_rule, h.J.map_creation_rules, 'exact');

%Update GUI h array
set(h.EDITwidth,'string',num2str(h.J.width));
set(h.EDITheight,'string',num2str(h.J.height));
set(h.EDITxwidth,'string',num2str(h.J.xwidth));
set(h.EDITxc,'string',num2str(h.J.xc));
set(h.EDITyc,'string',num2str(h.J.yc));
set(h.EDITiter,'string',num2str(h.J.N));
set(h.EDITc,'string',num2str(h.J.C));
set(h.EDITnancolor,'string',['[',num2str(h.J.NaN_colour),']']);
set(h.EDITclim,'string',['[',num2str(h.J.clim),']']);
set(h.EDITjuliafunction,'string',h.J.funcstr);
set(h.POPUPMENUmapfunction,'string',h.J.map_functions);
set(h.POPUPMENUmapcreationrule,'string',h.J.map_creation_rules);
set(h.POPUPMENUcolormap,'string',h.J.cmaps);
set(h.POPUPMENUmapfunction,'value',map_function_val);
set(h.POPUPMENUmapcreationrule,'value',map_creation_rule_val);
set(h.POPUPMENUcolormap,'value',cmap_val);
set(h.EDITmaxpixels,'string',num2str(h.J.max_pixels));
set(h.CHECKBOXdeletecomposites,'value',h.J.delete_composites);
set(h.CHECKplotalliter,'value',h.J.plot_all_iter);
set(h.CHECK3dsurf,'value',h.J.threeD_surf);
set(h.CHECK3and2dsurf,'value',h.J.threeD_and_twoD_surf);
set(h.EDITDPI,'string',num2str(h.J.output_bitmap_DPI));

%End of code