% matrix_invertor


%%%% GUI INITIALIZATION %%%%

%Top level GUI initialization
function varargout = matrix_invertor(varargin)

% Generic MATLAB GUI initialization. Edit at your peril!
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @matrix_invertor_OpeningFcn, ...
    'gui_OutputFcn',  @matrix_invertor_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

%%

% Outputs from this function are returned to the command line.
function varargout = matrix_invertor_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;

%%

% Code which executes just before matrix_invertor is made visible.
function matrix_invertor_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for matrix_invertor
handles.output = hObject;
guidata(hObject, handles);

%Store GUI object handles data in a global array d which can be seen (and
%modified) by all functions. This will be the main GUI data array which
%enables all objects to communicate with one another.
global d
d.h = handles; clear handles

%Initialize 3x3 matrix to invert
d.A = [ 3,2,-7 ; 1,-3,1; 0,2,-2 ];

%Update GUI
update_gui

%%

%Callback functions for matrix A elements
function A11_Callback(hObject, eventdata, handles); global d; d.A(1,1) = str2num( get(d.h.A11,'string') ); update_gui
function A12_Callback(hObject, eventdata, handles); global d; d.A(1,2) = str2num( get(d.h.A12,'string') );  update_gui
function A13_Callback(hObject, eventdata, handles); global d; d.A(1,3) = str2num( get(d.h.A13,'string') );  update_gui
function A21_Callback(hObject, eventdata, handles); global d; d.A(2,1) = str2num( get(d.h.A21,'string') );  update_gui
function A22_Callback(hObject, eventdata, handles); global d; d.A(2,2) = str2num( get(d.h.A22,'string') );  update_gui
function A23_Callback(hObject, eventdata, handles); global d; d.A(2,3) = str2num( get(d.h.A23,'string') );  update_gui
function A31_Callback(hObject, eventdata, handles); global d; d.A(3,1) = str2num( get(d.h.A31,'string') );  update_gui
function A32_Callback(hObject, eventdata, handles); global d; d.A(3,2) = str2num( get(d.h.A32,'string') );  update_gui
function A33_Callback(hObject, eventdata, handles); global d; d.A(3,3) = str2num( get(d.h.A33,'string') );  update_gui

%%

%Update GUI
function update_gui
global d

%Invert matrix A
[d.A_inv, d.det_A, d.M, d.C ] = matrix_inversion_recipe(d.A);

%Update GUI elements
set(d.h.A11,'string',num2str( d.A(1,1) ) );
set(d.h.A12,'string',num2str( d.A(1,2) ) );
set(d.h.A13,'string',num2str( d.A(1,3) ) );
set(d.h.A21,'string',num2str( d.A(2,1) ) );
set(d.h.A22,'string',num2str( d.A(2,2) ) );
set(d.h.A23,'string',num2str( d.A(2,3) ) );
set(d.h.A31,'string',num2str( d.A(3,1) ) );
set(d.h.A32,'string',num2str( d.A(3,2) ) );
set(d.h.A33,'string',num2str( d.A(3,3) ) );
set(d.h.C11,'string',num2str( d.C(1,1) ) );
set(d.h.C12,'string',num2str( d.C(1,2) ) );
set(d.h.C13,'string',num2str( d.C(1,3) ) );
set(d.h.C21,'string',num2str( d.C(2,1) ) );
set(d.h.C22,'string',num2str( d.C(2,2) ) );
set(d.h.C23,'string',num2str( d.C(2,3) ) );
set(d.h.C31,'string',num2str( d.C(3,1) ) );
set(d.h.C32,'string',num2str( d.C(3,2) ) );
set(d.h.C33,'string',num2str( d.C(3,3) ) );
C = d.C.';  %Transpose coactor matrix C
set(d.h.CT11,'string',num2str( C(1,1) ) );
set(d.h.CT12,'string',num2str( C(1,2) ) );
set(d.h.CT13,'string',num2str( C(1,3) ) );
set(d.h.CT21,'string',num2str( C(2,1) ) );
set(d.h.CT22,'string',num2str( C(2,2) ) );
set(d.h.CT23,'string',num2str( C(2,3) ) );
set(d.h.CT31,'string',num2str( C(3,1) ) );
set(d.h.CT32,'string',num2str( C(3,2) ) );
set(d.h.CT33,'string',num2str( C(3,3) ) );

set(d.h.EDITdetA,'string',num2str(d.det_A));

%%

% Matrix inversion code (for 3x3 matrix A)
function [A_inv, det_A, M, C ] = matrix_inversion_recipe(A)
a = A(1,1); b = A(1,2); c = A(1,3);
d = A(2,1); e = A(2,2); f = A(2,3);
g = A(3,1); h = A(3,2); i = A(3,3);

%Determine determinant of 3x3 matrix A
det_A = a*(e*i - f*h) - b*(d*i - f*g) + c*(d*h - e*g);
det_check = det(A) - det_A;  %Should be zero

%Calculate matrix of minors
M = [ e*i-f*h, d*i-f*g, d*h-e*g ; b*i-c*h, a*i-c*g, a*h-b*g ; b*f-c*e, a*f-c*d, a*e-b*d ];

%Calculate matrix of cofactors
C = M; C(1,2) = -C(1,2);  C(2,1) = -C(2,1);  C(2,3) = -C(2,3); C(3,2) = -C(3,2);

%Compute inverse
A_inv = C.' / det_A;
A_inv_check = A_inv - (A^-1); %Shouldl be a matrix of zeros.

%End of code
