%poweraid
% GUI which randomly generates integer powers, and optionally evaluates them.
% 
% LAST UPDATED by Andy French. September 2013.

function varargout = poweraid(varargin)

%% GUI initialization code %%
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @poweraid_OpeningFcn, ...
                   'gui_OutputFcn',  @poweraid_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

%%

%% GUI opensing function %%
function poweraid_OpeningFcn(hObject, eventdata, handles, varargin)

%Store figure data in global variable d
global d;

%Load allowed powers and bases
powerbase;
d.bases = bases;
d.powers = powers;

%Randomly choose base and power from allowed list
n = randi( [1,length(d.bases)], 1);
d.base = bases(n);
d.power = powers(n);

%Evaluate power as a decimal string (not standard form) to maximum precsion
d.answer = num2str( d.base^d.power, 19 );

%Update the power text boses
set( handles.TEXTbase,'string', num2str( d.base) );
set( handles.TEXTpower,'string', num2str( d.power) );
set( handles.TEXTanswer, 'string', ' ' );

%Load power-aid image
axes( handles.AXESpoweraid );
image( imread('power-aid.jpg'));
axis vis3d
axis off

%%

%% GUI output function %%
function varargout = poweraid_OutputFcn(hObject, eventdata, handles) 

%%

%% Callback for generate new power pushbutton %%
function PUSHnewpower_Callback(hObject, eventdata, handles)
global d;

%Randomly choose base and power from allowed list
n = randi( [1,length(d.bases)], 1);
d.base = d.bases(n);
d.power = d.powers(n);

%Update the power text boses
set( handles.TEXTbase,'string', num2str( d.base) );
set( handles.TEXTpower,'string', num2str( d.power) );

%Clear the answer box
set( handles.TEXTanswer,'string',' ' );

%%

%% Evaluate power pushbutton %%
function PUSHanswer_Callback(hObject, eventdata, handles)
global d;

%Evaluate power as a decimal string (not standard form) to maximum precsion
d.answer = num2str( d.base^d.power, 19 );

%Display answer in the answer text box
set( handles.TEXTanswer, 'string', ['= ',d.answer] );

%End of code