%ammonite_defaults
% Defines default parameters for the ammonite spheria. If S.SPHERIA does
% not have an ammonite field then it will obtain them from this function.

function d = ammonite_defaults

%Spiral types
d.spiral_type = 'Logarithmic';
d.spiral_types = {
    'Logarithmic',...
    'Linear',...
    'Archimedian'
    };
d.spiral_turns = 5;
d.points_per_turn = 200;
d.cross_section_ratio = 0.9;
d.helicity = 0;

%Plot spiral function in a separate window
d.plot_spiral = 0;

%Add ridges along ammonite (bumps on elliptical cross section)
d.add_ridges = 1;
d.ridge_frequency = 10;
d.bump_amplitude = 0.01;

%Add bumps along spiral
d.add_bumps = 0;
d.spiral_bump_amplitude = 0.5;
d.spiral_bump_frequency = 10;

%Colouring options
d.add_ridges_to_colour = 1;
d.add_bumps_to_colour = 1;

%Axes properties
d.axes_properties_fields = [];
d.axes_properties = [];

%% VIEW SETTINGS %%

%Camera position
d.S.campos_x = 14.859;
d.S.campos_y = 3.759;
d.S.campos_z = -8.1472;

%Camera target
d.S.camtarget_x = 0.10387;
d.S.camtarget_y = -0.10436;
d.S.camtarget_z = 0.18077;

%Camera up vector
d.S.camup_x = 0.3696;
d.S.camup_y = 0.39817;
d.S.camup_z = 0.83955;

%Camera view angle /degrees
d.S.camviewangle_deg = 4.8319;

%End of code