%hydrogenic_orbitals_defaults
% Defines default parameters for the hydrogenic orbital spheria. If S.SPHERIA does
% not have an spheria field then it will obtain them from this function.

function d = hydrogenic_orbitals_defaults

%Default parameters for hydrogenic_orbital
d.N = 200;
d.quantum_number_N = 5;
d.quantum_number_Ns = {'1','2','3','4','5','6','7','8','9','10'};
d.quantum_number_L = 'D';
d.quantum_number_Ls = LgivenN(d.quantum_number_N);
d.quantum_number_M = -2;
d.quantum_number_Ms = MgivenL(d.quantum_number_L);
d.Z = 1;
d.A = 1;
[w,d.E_eV,r_mean,r2_mean,a0,a] = Hradial(0,...
    d.quantum_number_N,...
    orbital2L(d.quantum_number_L),...
    d.Z,d.A);

%Axes properties
d.axes_properties_fields = [];
d.axes_properties = [];

%% VIEW SETTINGS %%

%Camera position
d.S.campos_x = 14.76;
d.S.campos_y = 3.8806;
d.S.campos_z = -8.2661;

%Camera target
d.S.camtarget_x = 0.004930;
d.S.camtarget_y = -0.017217;
d.S.camtarget_z = 0.061859;

%Camera up vector
d.S.camup_x = 0.3696;
d.S.camup_y = 0.39817;
d.S.camup_z = 0.83955;

%Camera view angle /degrees
d.S.camviewangle_deg = 5.7968;

%End of code