%klein_defaults
% Defines default parameters for the klein spheria. If S.SPHERIA does
% not have an klein field then it will obtain them from this function.

function d = klein_defaults

% Granularity down the pipe (default 100)
d.pipe_N = 100;

% Rotational granularity (default 50)
d.rot_N = 50;

% Radius of the top bend relative to the small pipe (default 3)
d.rtb = 3;

% Radius of the base relative to the small pipe (default 5)
d.rb2sp = 7;

% Height of the conical base relative to the small pipe (default 10)
d.hcb2sp = 8;

%Axes properties
d.axes_properties_fields = [];
d.axes_properties = [];

%% VIEW SETTINGS %%

%Camera position
d.S.campos_x = 11.1181;
d.S.campos_y = 10.8498;
d.S.campos_z = -7.7855;

%Camera target
d.S.camtarget_x = 0.063928;
d.S.camtarget_y = 0.083826;
d.S.camtarget_z = 0.20777;

%Camera up vector
d.S.camup_x = 0.28298;
d.S.camup_y = 0.36728;
d.S.camup_z = 0.88602;

%Camera view angle /degrees
d.S.camviewangle_deg = 4.0273;

%End of code