%polyspike_defaults
% Defines default parameters for the polyspike spheria. If S.SPHERIA does
% not have an polyspike field then it will obtain them from this function.

function d = polyspike_defaults

%Number of azimuth spikes
d.M = 12;

%Number of elevation spikes
d.N = 7;

%Spikiness
d.k = 1;

%Number of parabola points between spikes
d.P = 40;

%Axes properties
d.axes_properties_fields = [];
d.axes_properties = [];

%% VIEW SETTINGS %%

%Camera position
d.S.campos_x = 11.1181;
d.S.campos_y = 10.8498;
d.S.campos_z = -7.7855;

%Camera target
d.S.camtarget_x = 0.020338;
d.S.camtarget_y = 0.003651;
d.S.camtarget_z = 0.037163;

%Camera up vector
d.S.camup_x = 0.27595;
d.S.camup_y = 0.36033;
d.S.camup_z = 0.89107;

%Camera view angle /degrees
d.S.camviewangle_deg = 6.9535;


%End of code