%spheria_defaults
% Defines default parameters for the klein spheria. If S.SPHERIA does
% not have an spheria field then it will obtain them from this function.

function d = spheria_defaults

d.spherefunction = 'abs( cos(elev*azi)*sin(azi*elev) )' ;
d.sphere_or_surfaces = {
    'Sphere',...
    'Surface' };
d.sphere_or_surface = 'Surface';
d.N = 300;

%Axes properties
d.axes_properties_fields = [];
d.axes_properties = [];

%% VIEW SETTINGS %%

%Camera position
d.S.campos_x = 12.6941;
d.S.campos_y = 9.6992;
d.S.campos_z = 6.809;

%Camera target
d.S.camtarget_x = -0.008448;
d.S.camtarget_y = -0.050886;
d.S.camtarget_z = 0.058026;

%Camera up vector
d.S.camup_x = -0.31768;
d.S.camup_y = -0.22406;
d.S.camup_z = 0.92134;

%Camera view angle /degrees
d.S.camviewangle_deg = 7;

%End of code