%gen_sudoku
% Uses a group theoretic approach to generate Sudoku matrices. Not all
% Sudoku matrices can be generated in this way,but it's a quite large
% number. Based on code by Dario Fasino Dec 2005.
% http://www.dimi.uniud.it/fasino
% https://uk.mathworks.com/matlabcentral/fileexchange/9462-sudoku_lite

function sol = gen_sudoku

S = [1 2 3 ; 4 5 6 ; 7 8 9];
C = [7 8 9 1 2 3 4 5 6];
R = [3 1 2 6 4 5 9 7 8];
P = [1 2 3 4 5 6 7 8 9];
if rand < .5
    P(1) = 2; P(2) = 1;
    if rand < .5, P(3) = 6; P(6) = 3; end
    if rand < .5, P(8) = 9; P(9) = 8; end
    if rand < .5, P(4) = 7; P(7) = 4; end
else
    P(1) = 4; P(4) = 1;
    if rand < .5, P(9) = 6; P(6) = 9; end
    if rand < .5, P(8) = 7; P(7) = 8; end
    if rand < .5, P(2) = 5; P(5) = 2; end
end
C = P(C(P));
R = P(R(P));
sol = [S C(S) C(C(S))];
sol = [sol ; R(sol) ; R(R(sol))];
sol = sol([randperm(3) randperm(3)+3 randperm(3)+6], ...
    [randperm(3) randperm(3)+3 randperm(3)+6]);
per = randperm(9);
sol = per(sol);

%End of code