%sudoku_indices_from_S
% Return sudoku indices vectors p,q of elements of nth square set, for a
% sudoku with an alphabet of na elements
%
% LAST UPDATED by Andy French 30th January 2010

function [p,q] = sudoku_indices_from_S(n,na)
N = sqrt(na);
[r,c] = ind2sub( [N,N], n );
p = 1 + (r-1)*N : r*N;
q = 1 + (c-1)*N : c*N;
[p,q]=meshgrid(p,q);
p = reshape(p,[1,na]);
q = reshape(q,[1,na]);

%End of code