%sudoku_isbad
% Function which checks if a sudoku x is invalid.
%
% LAST UPDATED by Andy French 30th January 2010

function bad = sudoku_isbad(x,C,na)

%Initialise bad flag
bad = 0;

%Step through H,V and S sets and check that there are no non-zero
%duplicates of numbers.
for n=1:na
    H = x(n,:);
    V = x(:,n);
    S = sudoku_square_set( x, n );
    if nonzerodups(H) || nonzerodups(V) || nonzerodups(S)
        bad=1;
        return
    end
end

%Sudoku is also bad if there any empty elements of C
for n=1:na*na
    if isempty( C{n} )
        bad=1;
        return
    end
end

%%

%Binary function which checks for duplicates of non-zero elements of x 
function bool = nonzerodups(x)
bool = ~( length( nonzeros(x) ) == length( unique( nonzeros(x) ) )  );

%End of code