%square_set
% Find nth square set (returned as a vector) from sudoku x
%
% LAST UPDATED by Andy French 30th January 2010

function s = sudoku_square_set( x, n )

%Define size of square set. i.e. a square set has N^2 elements.
N = sqrt(sqrt(numel(x)));

%Find (row,column) indices of chosen square set, noting the sudoku is a
%set of N^2 square sets
[r,c] = ind2sub( [N,N], n );

%Sample sudoku x to yield output s, a row vector
s = x( 1 + (r-1)*N : r*N , 1 + (c-1)*N : c*N );
s = reshape( s, [1,N*N] );

%End of code