%edemo
% LAST UPDATED by Andy French May 2012

function varargout = edemo(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @edemo_OpeningFcn, ...
                   'gui_OutputFcn',  @edemo_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%%

% --- Executes just before edemo is made visible.
function edemo_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for edemo
handles.output = hObject;

%%% INPUTS %%%

% Number of data points
handles.edemo.N = 100;

% Axis limits
handles.edemo.xmin = -2;
handles.edemo.xmax = 5;
handles.edemo.ymin = 0;
handles.edemo.ymax = 30;

% Number of x data points
handles.edemo.N = 100;

% Fontsize
handles.edemo.fsize = 12;

% Base limits 
handles.edemo.bmin = 2;
handles.edemo.bmax = 4;
handles.edemo.b = 2;

% Vector of x values
handles.edemo.x = linspace(handles.edemo.xmin,...
    handles.edemo.xmax,handles.edemo.N);

% Create y vectors for limits of base
handles.edemo.y = handles.edemo.b.^handles.edemo.x;

% Compute gradients
[Y_pp,handles.edemo.dy_by_dx]=calculus(handles.edemo.x,...
handles.edemo.y,handles.edemo.x,'diff','spline',0);

% Update handles structure
guidata(hObject, handles);

%Centre figure
figcentre(gcf);

% Update GUI
set_edemo_gui_data
update_edemo

%%

% --- Outputs from this function are returned to the command line.
function varargout = edemo_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

%%

% --- Executes on slider movement.
function SLIDERb_Callback(hObject, eventdata, handles)

%Modify b using value of slider
handles = guidata(hObject);
v = get(handles.SLIDERb,'value');
handles.edemo.b = handles.edemo.bmin + v*(handles.edemo.bmax - handles.edemo.bmin);
guidata(gcf,handles);
set_edemo_gui_data
get_edemo_data
update_edemo

%%


function EDITbmax_Callback(hObject, eventdata, handles)
get_edemo_data
update_edemo

%%


function EDITbmin_Callback(hObject, eventdata, handles)
get_edemo_data
update_edemo

%%

function EDITxmin_Callback(hObject, eventdata, handles)
get_edemo_data
update_edemo

%%

function EDITxmax_Callback(hObject, eventdata, handles)
get_edemo_data
update_edemo

%%

function EDITymax_Callback(hObject, eventdata, handles)
get_edemo_data
update_edemo

%%

function EDITymin_Callback(hObject, eventdata, handles)
get_edemo_data
update_edemo

%%

function EDITb_Callback(hObject, eventdata, handles)

%Get data from GUI
h = guidata(gcf);

%Check b is not outside the limits
b = str2num( get(h.EDITb,'string') );
if (b > h.edemo.bmax) || (b < h.edemo.bmin)
    %Outide limits. Reset to old value
    set(h.EDITb,'string',num2str(h.edemo.b));
else
    %b value is in range. Update stored value.
    h.edemo.b = b;
end

%Update GUI data
guidata(gcf,h);

%Update GUI
set_edemo_gui_data
update_edemo

%%

function get_edemo_data

%Get data from GUI
h = guidata(gcf);

%Axes limits
h.edemo.xmin = str2num( get(h.EDITxmin,'string') );
h.edemo.xmax = str2num( get(h.EDITxmax,'string') );
h.edemo.ymin = str2num( get(h.EDITymin,'string') );
h.edemo.ymax = str2num( get(h.EDITymax,'string') );

%Base limits
h.edemo.bmin = str2num( get(h.EDITbmin,'string') );
h.edemo.bmax = str2num( get(h.EDITbmax,'string') );

%Current base
h.edemo.b = str2num( get(h.EDITb,'string') );

%Update GUI data
guidata(gcf,h)

%%

function update_edemo

%Get data from GUI
h = guidata(gcf);

%Create y vector for power law y = b^x
h.edemo.y = h.edemo.b.^h.edemo.x;

%Compute gradient
[Y_pp,h.edemo.dy_by_dx]=calculus(h.edemo.x,...
h.edemo.y,h.edemo.x,'diff','spline',0);

%Plot graph
axes(h.AXESedemo)
plot( h.edemo.x, real(h.edemo.y),'r',...
    h.edemo.x,real(h.edemo.dy_by_dx),'b-')
legend( { ['y=',num2str(h.edemo.b),'^x'],'dy/dx' } )
xlabel('x','fontsize',h.edemo.fsize)
ylabel('y','fontsize',h.edemo.fsize)
title('Power law y = b^x and its gradient','fontsize',h.edemo.fsize)
set(gca,'fontsize',h.edemo.fsize)
grid on;
xlim([h.edemo.xmin,h.edemo.xmax])
ylim([h.edemo.ymin,h.edemo.ymax])

%Update GUI data
guidata(gcf,h)

%%

function set_edemo_gui_data

%Get data from GUI
h = guidata(gcf);

%Axes limits
set(h.EDITxmin,'string',num2str(h.edemo.xmin));
set(h.EDITxmax,'string',num2str(h.edemo.xmax));
set(h.EDITymin,'string',num2str(h.edemo.ymin));
set(h.EDITymax,'string',num2str(h.edemo.ymax));

%Base limits
set(h.EDITbmin,'string',num2str(h.edemo.bmin));
set(h.EDITbmax,'string',num2str(h.edemo.bmax));

%Current base
set(h.EDITb,'string',num2str(h.edemo.b));

%Slider
set(h.SLIDERb,'value',(h.edemo.b - h.edemo.bmin)/(h.edemo.bmax-h.edemo.bmin));

%Update GUI data
guidata(gcf,h)

%%

%Centre figure in screen
function figcentre(fig)

%Get screen dimensions in pixels.
set(0,'units','pixels') ;
screen_size=get(0,'Screensize');

%Get original figure units
orig_units = get(fig,'units');

%Get position vector for figure in pixels
set(fig,'units','pixels');
fig_position=get(gcf,'position') ;

%Define coordinates or figure bottom hand corner from screen bottom hand corner
%that will place the figure window in the center of the screen.
centre_x = 0.5*screen_size(3) - 0.5*fig_position(3);
centre_y = 0.5*screen_size(4) - 0.5*fig_position(4);

%Modify figure position to centre
set(fig,'position',[centre_x,centre_y,fig_position(3),fig_position(4)] );

%Reset figure units
set(fig,'units',orig_units);

%%

%CALCULUS
% Function that fits a piecwise polynomial to an array of [X,Y] data and
% thus computes the derivative and cumulative integral of Y(X) at all
% points X. The function is based on the code written on pages 292 and 294
% of "Mastering Matlab 6" by Duane Hanselman & Bruce Littlefield.
%
% LAST UPDATED by Andrew French. 21/09/2004.
%
% Syntax: [Y_pp,Y_calc]=calculus(X,Y,X0,type,poly,C)
%
% X        - Vector of data X variable 
% Y        - Vector of data Y(X) variable
% X0       - Vector of X variables corresponding to that of the output.
% type     - 'integ' or 'diff'. Choses integration or diffrentiation of Y(X).
% poly     - 'spline' or 'hermite' . Choses type of piecewise polynomial
%            computed. Hermite polynomials tend to be better for 
%            non-smooth data and tends to be 'shape preserving.'
% C        - If type=='integ', this paramater gives the initial value of the
%            integral corresponding to X(1).
%
% Y_pp     - Piecewise polynomial fitted to Y(X) evaluated at X0. 
% Y_calc   - Vector of the same dimensions of X0, giving the
%            differential, or integral of Y(X) evaluated at all values of X0.
%
% Example: X=linspace(-2,2,20); Y=X.^2; 
% [Y_pp,Y_int]=calculus(X,Y,X,'integ','spline',0);
% [Y_int,YY]=calculus(X,Y_int,X,'diff','spline',0);
% plot(X,Y); hold on;
% plot(X,YY,'g');
% plot(X,Y_pp,'ro');
% legend('Y=X^2','Integral then derivative of Y=X^2','PP fit of Y=X^2');
% xlabel('X'); ylabel('Y');

function [Y_pp,Y_calc]=calculus(X,Y,X0,type,poly,C)

%Compute piecewise polynomial. Cubic spline is the default
if strcmp(poly,'hermite')==1
    pp=pchip(X,Y);
else
    pp=spline(X,Y);
end

%Check if integration or differentiation is required. Differentiation is
%the default option.
if strcmp(type,'integ')==1
    
    %Check that C is a scalar
    if prod(size(C))~=1
        error('C must be a scalar!')
    end
    
    %Take apart piecewise polynomial
    [br,co,npy,nco]=unmkpp(pp);
    
    %Scale factors for integration
    sf=nco:-1:1;
    
    %Integral coefficients
    ico=[co./sf(ones(npy,1),:) zeros(npy,1)];
    
    %Integral spline has higher order
    nco=nco+1;
    
    %Integration constant
    ico(1,nco)=C;
    
    %Find constant terms in polynomials
    for k=2:npy
        ico(k,nco)=polyval(ico(k-1,:),br(k)-br(k-1));
    end
    
    %Build pp form for integral
    ppi=mkpp(br,ico);
    
    %Evaluate integral at values of X0
    Y_calc=ppval(ppi,X0);
    
    %Evaluate piecewise polynomial
    Y_pp=ppval(pp,X0);
else
    
    %Take apart piecewise polynomial
    [br,co,npy,nco]=unmkpp(pp);
    
    %Scale factors for differentiation
    sf=nco-1:-1:1;
    
    %Derivative coefficients
    dco=sf(ones(npy,1),:).*co(:,1:nco-1);
    
    %Build pp form for derivative
    ppd=mkpp(br,dco);
    
    %Evaluate derivative at values of X0
    Y_calc=ppval(ppd,X0);  
    
    %Evaluate piecewise polynomial
    Y_pp=ppval(pp,X0);
end

%End of code



